/* 
   Este programa genera un fichero en el que se guarda un dato para
   cada tipo declarado en "tipos.x"
 
   Los valores de cada dato estn prefijados en este cdigo fuente,
   excepto para el ltimo dato (tipo MiUnion) en que se pide al
   usuario el tipo deseado y el valor para ese caso.
*/
#include "tipos.h"
int main(int argc, char *argv[])
{
  /* Declaramos una variable de cada tipo */
  Entero i;
  Real   x;
  Texto  t;              /* Es en realidad un puntero a char */
  ArrayFijoEnteros af;   /* Es un array de 4 */
  ArrayVariableEnteros av;
  MiUnion u;

  /* Declaramos las variables necesarias para que los filtros
     escriban en un fichero los datos */
  FILE *fichero;
  XDR  operacion;

  /* Otras variables auxiliares */
  int j;   /* Para bucles */
  char txtaux[20];   /* buffer para leer texto del teclado */
  
  /* Comienza la ejecucin, inicializando las variables */
  /* Inicializar el entero */
  i = 10;  
 
  /* Inicializar el flotante */
  x = 1.0;

  /* Inicializar el texto, que es en realidad un puntero a char */
  t = "Prueba";   /* Hacemos apuntar el puntero a la cadena "Prueba" */

  /* Inicializar el array fijo de 4 enteros */
  for (j=0; j<4; j++)   af[j]=j*2;

  /* Inicializar el array variable con 3 enteros de valores 1,2, y 3 */
  av.ArrayVariableEnteros_len=3;
  av.ArrayVariableEnteros_val=malloc(3*sizeof(int));
  for (j=0; j<3; j++)  av.ArrayVariableEnteros_val[j]=j+1;

  /* Inicializar la union (preguntando al usuario) */
  printf("Elija el tipo para la unin:\n");
  printf(" 1: Entero\n");
  printf(" 2: Real\n");
  printf(" 3: Texto\n");
  printf(" 4: ArrayFijoEnteros\n");
  printf(" otro: sin datos\n");
  printf("Su eleccin: ");
  scanf("%d", &u.tipo);
  /* Pedir el dato, dependiendo del tipo elegido */
  switch(u.tipo) {
  case 1: 
    printf("Valor del entero: ");
    scanf("%d", &u.MiUnion_u.i);
    break;
  case 2: 
    printf("Valor del real: ");
    scanf("%f", &u.MiUnion_u.x);
    break;
  case 3: 
    /* Leer el retorno de carro que qued tras el ltimo scanf, para
       evitar que fgets lo encuentre y lea una linea en blanco. */ 
    getchar();
    printf("Escriba un texto: ");
    fgets(txtaux, 20, stdin); /* Leer la lnea */
    u.MiUnion_u.t=txtaux;   /* Hacemos apuntar el puntero al buffer auxiliar */
    break;
  case 4: 
    for (j=0; j<4; j++) {
      printf("Valor del entero[%d]: ", j);
      scanf("%d", &u.MiUnion_u.a[j]);
    }
    break;
  default:
    printf("No se requiere dato\n");
  }

  /* Creacin del fichero para guardar los datos */
  fichero=fopen("Datos.xdr", "w");
  if (fichero==NULL) {
    perror("Al crear el fichero");
    exit(-1);
  }
  /* Preparacin de la operacin para codificar */
  xdrstdio_create(&operacion, fichero, XDR_ENCODE);

  /* Llamada a los filtros para volcar los datos */
  if (xdr_Entero(&operacion, &i)!=TRUE) {
    fprintf(stderr, "Error al escribir el Entero\n");
  }
  /* Completar lo que falta para que se vuelquen los restantes datos,
     en el orden en que han sido declarados en main()
  */


  fflush(fichero);   /* Para forzar el volcado */
  /* Una vez almacenado, podemos destruir la estructura XDR 
     y cerrar el fichero */
  xdr_destroy(&operacion);
  fclose(fichero);
  printf("\nFichero generado\n");
}
